#include			<stdio.h>                                                      
#include			<conio.h>
#include			<stdlib.h>
#include			<alloc.h>
#include			<float.h>
#include			<math.h>
#include			<graphics.h>
#include			<string.h>
#include			<dos.h>
#include			<time.h>
#include			<process.h>
#include			<menu.h>		/* The menu library	*/
#include			"adeshdef.h"
#include			"adeshve.h"
#include			"adeshsub.h"
#include			"iapdef.h"

float get_IAP_4_energy(int atom_no, int atom_element, float x, float y, float z)
 {
	int i, j, nebs, Neb_Par_Defined, k, i1;
	float d, e, f, g, h, g1, g2;
	float	a, b, c;

	double	Ion_Charge_1, Ion_Charge_2, CapA, Rho, CapC;
	double	Spring_K_2, Spring_K_1;
	double	Core_Charge_1, Core_Charge_2, Shell_Charge_1, Shell_Charge_2;
	double SM_ENERGY;
	double w,v,u,r2;
	double	QR_Sum, Charge_Inside;
	struct atom_specs *neb_ptr;

	if(atom_element == VACANCY)
	return(0.);

	neb_ptr = atom_ptr_temp;
	SM_ENERGY = 0.;
	w=1.;
	u=0.;

	nebs = 0;

	Ion_Charge_1 = Element[atom_element].IAP_PAR[1];
	Shell_Charge_1 = Element[atom_element].IAP_PAR[2];
	Spring_K_1 = Element[atom_element].IAP_PAR[3];
	Core_Charge_1=Ion_Charge_1 - Shell_Charge_1;
	Charge_Inside = Ion_Charge_1;
	QR_Sum=0.;
	Total_Charge=Total_Charge+Element[atom_element].IAP_PAR[1];

//				WindowPrintf(pw,"\n Current Atom : %s\n", Chem_Sym[atom_element]);

	i=0;
	while(i<Total_Atoms)
	{

	 if((i != atom_no) && (neb_ptr->TYPE != VACANCY))
		{
			d = neb_ptr->XC;
			e = neb_ptr->YC;
			f = neb_ptr->ZC;

			g2 = Element[atom_element].IAP_PAR[0];

			/* Parameter zero is cut_off distance square */
			g1= Element[(int)neb_ptr->TYPE].IAP_PAR[0];
			g1=(float) sqrt((double) g1);
			g2=(float) sqrt((double) g2);
			h=(g2+g1)/2.0;
		/* Parameter zero is cut_off distance square */
			g=h*h;

			if( Is_Neb(x, y, z, d, e, f, h, g) == 0)
			 {
				if((Element[neb_ptr->TYPE].IAP_TYPE != INTER_ATOM_POT_4) &&
					(Element[neb_ptr->TYPE].IAP_TYPE != INTER_ATOM_POT_NULL))
					{
						Energy_Error = IAP_TYPE_DIFERENT;
						neb_ptr++;
						i++;
						continue;
					/* Neighbor atom has a different potential type */
					 }
				if(Element[neb_ptr->TYPE].IAP_TYPE == INTER_ATOM_POT_NULL)
				 {
					neb_ptr++;
					i++;
					continue;
				 }

/*		IAP_PAR sequence :
	0 : r_cut_square
	1 : Ion_Charge
	2 : Shell_Charge
	3 : Spring_K
	4 : Cap_A
	5 : Rho
	6 : Cap_C
	7 : Neb Type
	8 : Cap_A
	9 : Rho
	10: Cap_C
	11: Neb Type ...
	15: Neb Type ...
	19: R_Outside

*/
						Ion_Charge_2 = Element[(int)neb_ptr->TYPE].IAP_PAR[1];
						Shell_Charge_2 = Element[(int)neb_ptr->TYPE].IAP_PAR[2];
						Spring_K_2 = Element[(int)neb_ptr->TYPE].IAP_PAR[3];
						Core_Charge_2 = Ion_Charge_2 - Shell_Charge_2;

				Neb_Par_Defined=DESH_NO;
				if(neb_ptr->TYPE == atom_element)
					{
						CapA = Element[atom_element].IAP_PAR[4];
						Rho = Element[atom_element].IAP_PAR[5];
						CapC = Element[atom_element].IAP_PAR[6];
						Neb_Par_Defined=DESH_YES;
					}
				if(neb_ptr->TYPE == Element[atom_element].IAP_PAR[7])
					{
						CapA = Element[atom_element].IAP_PAR[8];
						Rho = Element[atom_element].IAP_PAR[9];
						CapC = Element[atom_element].IAP_PAR[10];
						Neb_Par_Defined=DESH_YES;
					}
				if(neb_ptr->TYPE == Element[atom_element].IAP_PAR[11])
					{
						CapA = Element[atom_element].IAP_PAR[12];
						Rho = Element[atom_element].IAP_PAR[13];
						CapC = Element[atom_element].IAP_PAR[14];
						Neb_Par_Defined=DESH_YES;
					}
				if(neb_ptr->TYPE == Element[atom_element].IAP_PAR[15])
					{
						CapA = Element[atom_element].IAP_PAR[16];
						Rho = Element[atom_element].IAP_PAR[17];
						CapC = Element[atom_element].IAP_PAR[18];
						Neb_Par_Defined=DESH_YES;
					}

/* Now compute the energy */

						for(j=0; j<Periodic_Nebs_Found; j++)
							{
								r2 = Periodic_Neb_Distances[j];
								w=sqrt(r2);
								v=0.;
								if(w < 0.5)
									{
/* Atoms are too close !   Return a high value instead of math error */
										return(10000.);
									}

/* Buckingham Potential */

								if((Rho > 0.) && (Neb_Par_Defined == DESH_YES))
									v=CapA*exp(-w/Rho)-CapC/(r2*r2*r2);

/* Coulombic interaction

	Energy = (q1 * q2) / (4 * pi * epsionlon_0 * r)

	q1 and q2 are in units of electric charge
	r is in Angstoms

	Energy = 14.39 * (q1 * q2) / r  in eV

	Interactions are Core_1 to Core_2
									 Core_1 to Shell_2
									 Shell_1 to Core_2
									 Shell_1 to Shell_2

	The Core_1 to Shell_1 and Core_2 to Shell_2 interaction is from
	polarization. It is computed as

	(1/2) * Spring_K_1 * (Core_Shell_Distance)**2

*/

/* We are not using the polarization term in this study. Hence the
	 sum of following terms is the product of ionic charges
*/
								u = 14.39 * Core_Charge_1 * Core_Charge_2 / w;
								u = u + 14.39 * Core_Charge_1 * Shell_Charge_2 /w;
								u = u + 14.39 * Shell_Charge_1 * Core_Charge_2 / w;
								u = u + 14.39 * Shell_Charge_1 * Shell_Charge_2 / w;

//								u = 14.39 * Ion_Charge_1 * Ion_Charge_2 / w;


								SM_ENERGY = SM_ENERGY + v + u;
//							Charge_Inside = Charge_Inside+Shell_Charge_2+Core_Charge_2;
								Charge_Inside = Charge_Inside + Ion_Charge_2;
/*
								WindowPrintf(pw, "\nIon : %s  Charge : %6.2f  Total : %7.2f",
									Chem_Sym[(int)neb_ptr->TYPE], (float)Ion_Charge_2, (float)Charge_Inside);
								i1=getch();
*/
								QR_Sum = QR_Sum + Ion_Charge_2 * w;
								nebs++;
/*
								WindowPrintf(pw,"    %s Neb %2d %s  r=%6.3f %7.2f  %7.2f  %7.2f\n",
									Chem_Sym[atom_element], nebs, Chem_Sym[(int)neb_ptr->TYPE],
									(float)w, (float) v, (float)u, (float) SM_ENERGY);
								k=getch();
*/
							}

			 }
		}

	 i++;
	 neb_ptr++;
	}

/*
	The sum of charge times distance divided by total charge is the
	distance (QR_Sum / Total_Charge).
	Total Charge of opposite sign at this distance is used
	to compute the correction factor
*/
	v=0.;
//	if(QR_Sum != 0)
	if((QR_Sum > .001) || (QR_Sum < -.001))
		{
			v = - (Ion_Charge_1 * Charge_Inside * Charge_Inside *14.89) / QR_Sum;
		}

	nebs1=nebs;
/*
	WindowPrintf(pw, "\nInside Charge : %7.1f\n Nebs : %d", (float)Charge_Inside, nebs);
	WindowPrintf(pw, "\nWithout correction : %7.2f\n", (float)SM_ENERGY/2.);
	WindowPrintf(pw, "\nQR_Sum = %7.1f\n  Correction = %7.2f\n", (float)QR_Sum, v/2.);
	i=getch();
*/
	SM_ENERGY = SM_ENERGY + v;
	return((float)SM_ENERGY/2.);


/* Since each pair gets counted twice, divide energy value by 2 */

 }

